#include <vector>
#include <string>
#include <QWidget>
#include <QObject>
#include "ui_ModeEqWidget.h"

class FloatSliderPlus ;
class MyViewer ;
class QCheckBox;

class ModeEqWidget: public QWidget, public Ui::ModeEqW
{
	Q_OBJECT

	public:
		ModeEqWidget(const std::string& path) ;
		virtual ~ModeEqWidget() ;

	public slots:
		void sliderUpdated() ;
		void saveExrImage() ;
		void setAveragePolicy(bool) ;
		void coefsChanged(int);
		void changeGain(float);
		void setShowWhat(int);
		void updateImage() ;

	private:
		void updateImage_basic() ;
		void updateImage_SSE2() ;

		std::vector<const float *> _eigen_vectors ;
		std::vector<float> _means ;
		std::vector<std::pair<float,float> > _ranges ;

		float *_mean ;
		QCheckBox *_use_sse_CB ;
		std::vector<FloatSliderPlus*> _sliders ;
		std::vector<float> _current_coefs ;
		std::vector<float*> _col_channels ;
		int _w,_h ;
		bool _av_policy ;
		float _gamma ;
		int _show_what ;
		MyViewer *_viewer ;
		float *_pix ;
};

