#ifndef _EMDECOMP_2D_H_
#define _EMDECOMP_2D_H_

#include<DataMat.h>
#include <vector>
#include<iostream>
#include <iterator>
#include <map>
#include <algorithm>
#include <functional>  
#include <Magick++.h> 
using namespace std; 


class EMDecomposer2D
{
        public:
                EMDecomposer2D() ;
                void                    RunColorDecomposition(const DataMat& data,  const DataMat& datar, const DataMat& datag, const DataMat& datab, 
                                                                int NModes, double Thresh) ;                                
                void                    RunDecomposition(const DataMat& data,  int NModes) ;
                
		const vector<DataMat>&  GetIMFs() const { return _IMFs; }
                
        private:                
                void AddConstraintsIfSparse(const DataMat& data, DataMat& MinMat, DataMat& MaxMat, int KSize, double Thresh); 
					 
                void ComputeMeanEnvelope(const DataMat& d,  const DataMat& MinEnv, const DataMat& MaxEnv, DataMat& Mean ) ;
                                
                
                vector<DataMat> _IMFs, _IMFsR, _IMFsG, _IMFsB ;                
                double _MaxDR ; // Warning : temp var use carefully
};


#endif //_EMDECOMP_2D_H_